
------ Water in the tub -- version 2 - Discrete Steps

function createObserverChart (terrame_object, attr_names)
	chart = Observer {
		subject = terrame_object,
		attributes = attr_names,
		curveLabels = attr_names,
		type = "chart"
	}
end

----

function createPlot (model)

	model.plot = Cell (model.values)

	createObserverChart (model.plot, model.attributes) 

end

------------------
function createTimer (model)

	model.timer = Timer {

		Event{time = 1, period = 1, action = function()
			waterOutflow (model)
		end},

		Event {time = 0, period = 0.25, action = function(ev)
    		model.plot:notify(ev:getTime())			
		end}
	}
end

-----------------

function run (model, time)
	model.timer:execute (time)
end
-------------------

waterOutflow = function (model)
	model.values.water = model.values.water - 5
end

------
function SystemDynamicsModel(model)

	-- create Plot

	createPlot (model)

	-- timer
	createTimer (model)

	return model
end

model =  SystemDynamicsModel {
	attributes    = { "water" },
	values        = { water = 100, tub = 200 }
}
run (model, 8)